def moritz_achilles(p, q):
    # Начальная пара дробей
    left_numerator, left_denominator = 0, 1
    right_numerator, right_denominator = 1, 0
    path = ""
    while True:
        mid_numerator = left_numerator + right_numerator
        mid_denominator = left_denominator + right_denominator

        if mid_numerator == p and mid_denominator == q:
            return path

        if mid_numerator * q < p * mid_denominator:
            path += 'R'
            left_numerator, left_denominator = mid_numerator, mid_denominator
        else:
            path += 'L'
            right_numerator, right_denominator = mid_numerator, mid_denominator


a = list(map(int, input().split()))
fraction = (a[0],a[1])
result = moritz_achilles(fraction[0], fraction[1])
print('R' + result)