from collections import deque, defaultdict

vod = list(map(int, input().split()))
n = vod[0]
m = vod[1]
k = vod[2]
graph = defaultdict(list)

for _ in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)
guarded = set()
for _ in range(k):
    p, h = map(int, input().split())
    queue = deque([(p, 0)])
    visited = {p}

    while queue:
        current, dist = queue.popleft()
        if dist > h:
            continue
        guarded.add(current)
        for neighbor in graph[current]:
            if neighbor not in visited:
                visited.add(neighbor)
                queue.append((neighbor, dist + 1))

print(len(sorted(guarded)))
print(' '.join(map(str,(sorted(guarded)))))