from collections import deque, defaultdict


n, m, k = map(int, input().split())
graph = defaultdict(list)

for qw in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)

guarded = set()

for qw in range(k):
    p, h = map(int, input().split())
    queue = deque([(p, 0)])
    visited = {p}

    while queue:
        current, dist = queue.popleft()
        if dist > h:
            continue
        guarded.add(current)
        for neighbor in graph[current]:
            if neighbor not in visited:
                visited.add(neighbor)
                queue.append((neighbor, dist + 1))


guarded = sorted(guarded)
print(len(guarded))
print(' '.join(map(str,guarded)))