a = input().strip()
b = input().strip()

def moon_sum(a, b):
    max_len = max(len(a), len(b))
    a_padded = a.zfill(max_len)
    b_padded = b.zfill(max_len)
    result = ''
    for digit_a, digit_b in zip(a_padded, b_padded):
        result += max(digit_a, digit_b)
    return result


def moon_multiply(a, b):
    partial_results = []
    for idx_b, digit_b in enumerate(reversed(b)):
        partial = ''
        # Перебор цифр первого числа
        for digit_a in a:
            partial += min(digit_a, digit_b)
        partial += '0' * idx_b
        partial_results.append(partial)
    result = '0'
    for partial in partial_results:
        max_len = max(len(result), len(partial))
        result_padded = result.zfill(max_len)
        partial_padded = partial.zfill(max_len)
        new_result = ''
        for digit_r, digit_p in zip(result_padded, partial_padded):
            new_result += max(digit_r, digit_p)
        result = new_result
    return result

sum_result = moon_sum(a, b)
product_result = moon_multiply(a, b)
print(f"{sum_result} {product_result}")